mcer/issues/urls.py
from django.conf.urls import url
from mcer.issues.views import issues_list, categories_list, category_new, issue_new, issue_detail, issue_edit, issue_save
urlpatterns = [    
    url(r'^$',issues_list),
    url(r'^new$',issue_new),
    url(r'(?P<issue_id>[0-9]+)$',issue_detail),
    url(r'(?P<issue_id>[0-9]+)/edit$',issue_edit),
    url(r'(?P<issue_id>[0-9]+)/save$',issue_save),
    url(r'^categories/$',categories_list),
    url(r'^categories/new$',category_new),
]

mcer/urls.py
from django.conf.urls import url, include
from django.contrib.auth import views as auth_views

urlpatterns = [    
    url(r'^login/$', auth_views.LoginView.as_view(template_name='login.html')),
    url(r'^logout/$', auth_views.LogoutView.as_view(template_name='logout.html')),    
    url(r'^issues/',include('mcer.issues.urls')),
    url(r'^users/',include('mcer.users.urls')),
]

mcer/users/urls.py
from django.conf.urls import url
from mcer.users.views import users_list, user_new, denied

urlpatterns = [    
    url(r'^$',users_list),
    url(r'^new$',user_new),    
    url(r'^denied$',denied),
]

mcer/issues/models.py
from django.db import models
from django.conf import settings

class Categories(models.Model):
    def __str__(self):
        return u'{0}'.format(self.label)
    label = models.CharField(max_length=32)

class Issues(models.Model):
    owner = models.ForeignKey(settings.AUTH_USER_MODEL, related_name='owner')
    solver = models.ForeignKey(settings.AUTH_USER_MODEL, related_name='solver')
    category = models.ForeignKey(Categories, related_name='category')
    state = models.IntegerField(choices = [(0,'New'),(1,'Working'),(2,'Finished'),(3,'Closed')])
    label = models.CharField(max_length=32)
    description = models.TextField()
    time_min = models.IntegerField()

mcer/users/models.py
from django.db import models

# Create your models here.

mcer/issues/forms.py
from django import forms
from mcer.issues.models import Categories, Issues

class CategoryForm(forms.ModelForm):
    class Meta:
        model = Categories
        fields = ['label']

class IssueForm(forms.ModelForm):
    class Meta:
        model = Issues
        fields = ['owner','solver','state','category','label','description','time_min']
        widgets = {
            'owner': forms.HiddenInput(),            
        }

mcer/users/forms.py
from django import forms
from django.contrib.auth.models import User

class UserForm(forms.ModelForm):
    class Meta:
        model = User
        fields = ['username','password']
        widgets = {
            'password': forms.PasswordInput(),
        }

mcer/issues/views.py
from django.shortcuts import render, redirect
from mcer.issues.models import Categories, Issues
from mcer.issues.forms import CategoryForm, IssueForm
from django.contrib.auth.decorators import user_passes_test
from mcer.utils import is_superuser, is_staff
from django.db.models import Min, Avg, Max

@user_passes_test(is_staff,login_url = "/login/")
def issues_list(request):
    if request.user.is_superuser:
        issues = Issues.objects.all()        
        min_time = Issues.objects.all().aggregate(Min('time_min'))
        avg_time = Issues.objects.all().aggregate(Avg('time_min'))
        max_time = Issues.objects.all().aggregate(Max('time_min'))
    else:
        issues = Issues.objects.filter(solver = request.user)
        min_time = Issues.objects.filter(solver = request.user).aggregate(Min('time_min'))
        avg_time = Issues.objects.filter(solver = request.user).aggregate(Avg('time_min'))
        max_time = Issues.objects.filter(solver = request.user).aggregate(Max('time_min'))        
    return render(request, 'issues/list.html', {
        'issues': issues,
        'min_time': min_time, 'avg_time': avg_time, 'max_time':max_time,
        'form': IssueForm(initial={'owner':request.user}),
    })

@user_passes_test(is_superuser,login_url = "/users/denied")
def issue_new(request):
    f = IssueForm(request.POST)
    if f.is_valid():
        f.save()
    return redirect('/issues/')    

@user_passes_test(is_staff,login_url = "/login")
def issue_detail(request,issue_id):
    issue = Issues.objects.get(pk = issue_id)
    if request.user.is_superuser or (issue.solver == request.user):
        return render(request, 'issues/detail.html', {
            'issue': issue,        
        })
    else:
        return render(request, 'users/denied.html')

@user_passes_test(is_superuser,login_url = "/users/denied")
def issue_edit(request,issue_id):
    return render(request, 'issues/edit.html', {
        'issue_id': issue_id,
        'form': IssueForm(instance=Issues.objects.get(pk = issue_id)),        
    })

@user_passes_test(is_superuser,login_url = "/users/denied")
def issue_save(request,issue_id):
    f = IssueForm(request.POST, instance=Issues.objects.get(pk = issue_id))
    f.save()
    return redirect('/issues/')

@user_passes_test(is_superuser,login_url = "/users/denied")
def categories_list(request):
    return render(request, 'issues/categories.html', {
        'categories': Categories.objects.all(),
        'form':CategoryForm()
    })

@user_passes_test(is_superuser,login_url = "/users/denied")
def category_new(request):
    f = IssueForm(request.POST)    
    if f.is_valid():
        f.save()
    return redirect('/issues/categories')
    

mcer/users/views.py
from django.shortcuts import render, redirect
from django.contrib.auth.models import User
from mcer.users.forms import UserForm
from django.contrib.auth.decorators import user_passes_test
from mcer.utils import is_superuser

@user_passes_test(is_superuser,login_url = "/users/denied")
def users_list(request):
    return render(request, 'users/list.html', {
        'users': User.objects.all(),
        'form':UserForm(initial = {'username': '','password':''})
    })

@user_passes_test(is_superuser,login_url = "/users/denied")
def user_new(request):
    f = UserForm(request.POST)
    if f.is_valid():        
        user = User.objects.create_user(f['username'].value(), '', f['password'].value())
        user.is_staff = 1
        user.save()
    return redirect('/users/')

def denied(request):
    return render(request,'users/denied.html')

mcer/templates/base.html
{% load bootstrap3 %}
<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <title>Imba IT - {% block title %} {% endblock %}</title>
    {% bootstrap_css %}
  </head>
  
  <body>          
    <main role="main" class="container">
        {% if user.is_authenticated %}
        {% include 'menu.html' %}
        {% endif %}
        {% block content %}{% endblock content %}
    </main>
    {% bootstrap_javascript jquery=1 %}
  </body>
</html>

mcer/templates/issues/categories.html
{% extends 'base.html' %}
{% load bootstrap3 %}
{% block title %} - Issue Categories{% endblock %}

{% block content %}
<h1>Categories</h1>
<ul>
    {% for category in categories %}
    <li>{{ category.label}}</li>
    {% endfor %}
</ul>
<hr>
<h3>Add new</h3>
<form method="post" action="/issues/categories/new">        
    {% csrf_token %}
    {% bootstrap_form form %}
    {% buttons %}
    <button type="submit" class="btn btn-primary">Save</button>
    {% endbuttons %}    
</form>
{% endblock %}

mcer/templates/issues/detail.html
{% extends 'base.html' %}
{% load bootstrap3 %}
{% block title %} - {{issue.label}}{% endblock %}
{% block content %}
<h1>{{issue.label}}</h1>
<p>{{ issue.description }}</p>
<table class="table">
    <tr><td>Owner</td><td>{{ issue.owner.username }}</td></tr>
    <tr><td>Solver</td><td>{{ issue.solver.username }}</td></tr>
    <tr><td>Category</td><td>{{ issue.category.label }}</td></tr>
    <tr><td>Status</td><td>{{ issue.get_state_display }}</td></tr>
    <tr><td>Time spent (min)</td><td>{{ issue.time_min }}</td></tr>
</table>
{% if user.is_superuser %}
<a href="/issues/{{issue.id}}/edit" class="btn btn-primary">edit</a>
{% endif %}
{%endblock %}

mcer/templates/issues/edit.html
{% extends 'base.html' %}
{% load bootstrap3 %}
{% block title %}Issues{% endblock %}

{% block content %}
<h3>{{form.label.value}}</h3>
<form method="post" action="/issues/{{issue_id}}/save">        
    {% csrf_token %}
    {% bootstrap_form form %}
    {% buttons %}
    <button type="submit" class="btn btn-primary">Save</button>
    {% endbuttons %}    
</form>

{% endblock %}

mcer/templates/issues/list.html
{% extends 'base.html' %}
{% load bootstrap3 %}
{% block title %}Issues{% endblock %}

{% block content %}
<strong>Min Time:</strong>{{min_time.time_min__min}} min<br>
<strong>Max Time:</strong>{{max_time.time_min__max}} min<br>
<strong>Avg Time:</strong>{{avg_time.time_min__avg}} min<br>
<hr>
<table class="table">
    <tr><th>#</th><th>Owner</th><th>Solver</th><th>Status</th><th>Category</th><th>Label</th><th>Time spent</th><th>&nbsp;</th></tr>
    {% for issue in issues %}
    <tr>
        <td>{{issue.id}}</td>
        <td>{{issue.owner.username}}</td><td>{{issue.solver.username}}</td><td>{{issue.get_state_display}}</td>
        <td>{{issue.category.label}}</td>
        <td><a href="/issues/{{issue.id}}">{{issue.label}}</a></td>
        <td>{{issue.time_min}}</td>
        {% if user.is_superuser %}
        <td><a href="/issues/{{issue.id}}/edit" class="btn btn-xs btn-primary">edit</a></td>
        {% endif %}
    </tr>
    {% endfor %}
</table>
{% if user.is_superuser %}
<h3>Add new</h3>
<form method="post" action="/issues/new">        
    {% csrf_token %}
    {% bootstrap_form form %}
    {% buttons %}
    <button type="submit" class="btn btn-primary">Save</button>
    {% endbuttons %}    
</form>
{% endif %}
{% endblock %}

mcer/templates/login.html
{% extends 'base.html' %}
{% load bootstrap3 %}
{% block title %} - Login{% endblock %}

{% block content %}
   <h1>Login</h1> 
  <form method="post">
    {% csrf_token %}
    {% bootstrap_form form %}
    {% buttons %}
    <button type="submit" class="btn btn-primary">Login</button>
    {% endbuttons %}

  </form>
{% endblock %}

mcer/templates/logout.html
{% extends 'base.html' %}
{% block title %} - Logout{% endblock %}

{% block content %}
<h2>Bye</h2>
<hr>
<a class="btn btn-primary" href="/login/">Login</a>
{% endblock %}

mcer/templates/menu.html
<nav class="navbar navbar-default">
        <div class="container-fluid">
          <!-- Brand and toggle get grouped for better mobile display -->
          <div class="navbar-header">
            <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1" aria-expanded="false">
              <span class="sr-only">Toggle navigation</span>
              <span class="icon-bar"></span>
              <span class="icon-bar"></span>
              <span class="icon-bar"></span>
            </button>
            <a class="navbar-brand" href="/issues/">Imba Issue Tracker</a>
          </div>
      
          <!-- Collect the nav links, forms, and other content for toggling -->
          <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1">
            <ul class="nav navbar-nav">              
              <li><a href="/issues/">Issues</a></li>
              {% if user.is_superuser %}
              <li><a href="/issues/categories/">Categories</a></li>
              <li><a href="/users/">Users</a></li>
              {% endif %}
            </ul>
            <ul class="nav navbar-nav navbar-right">              
                <li class="dropdown">
                    <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">{{ user.username }} <span class="caret"></span></a>
                    <ul class="dropdown-menu">
                        <li><a href="/logout/">Logout</a></li>
                    </ul>    
                </li>
            </ul>
          </div>
        </div>
      </nav>

mcer/templates/users/denied.html
{% extends 'base.html' %}

{% block title %} - Access denied{% endblock %}

{% block content %}
   <h1>Acces denied</h1> 
   {% if user.is_staff %}
   You must be superuser to run operation.
   {% else %}
   <a href = "/login/?next={{request.GET.next}}">You have to login as superuser</a>
   {% endif %}
{% endblock %}

mcer/templates/users/list.html
{% extends 'base.html' %}
{% load bootstrap3 %}
{% block title %} - Staff Users{% endblock %}

{% block content %}
<h1>Users</h1>
<ul>
    {% for user in users %}
    <li>{{ user.username}}</li>
    {% endfor %}
</ul>
<hr>
<h3>Add new</h3>
<form method="post" action="/users/new">        
    {% csrf_token %}
    {% bootstrap_form form %}
    {% buttons %}
    <button type="submit" class="btn btn-primary">Save</button>
    {% endbuttons %}    
</form>
{% endblock %}